{ This is the library of routines that are used by the contestants to
   simulate dropping the objects.

		A compiled version of this library was given to each contestant.
	  The source code was not given to them.
}


unit newsLib;

interface

function Oracle(x:integer; y:integer; slope:integer):integer;
procedure Decide( x:integer; y:integer ) ;

implementation


const MX = 15;
const BUFFER_LENGTH = 256;

var
  solx, soly : integer;
  globaloutfp : text;

procedure error_quit(  msg:string );
begin
        write('NEWS: Error: ');
        writeln(msg);
	halt(1);
end;

procedure initialize;
var
        infp : text;
begin

{$I-}
        assign(infp,'xoracle.in');
        reset(infp);

        if( IOResult <> 0 ) then                error_quit( 'Unable to open xoracle.in' );
        read(infp,solx);
if IOResult <> 0 then error_quit( 'Unable to read two integers from xoracle.in');
        read(infp,soly);
if IOResult <> 0 then error_quit( 'Unable to read two integers from xoracle.in');

        close( infp );
if IOResult <> 0 then error_quit( 'Unable to read two integers from xoracle.in');


end;

procedure cleanup;
begin
   solx := 0;
   soly := 0;
end;


function sign(x:integer):integer;
var
   retval : integer;
begin
    retval := 0;
    if (x > 0) then retval := 1;
    if (x < 0) then retval := -1;
    sign:=retval;
end;


procedure checkCoordinates(x,y: integer);
begin
  if( (x<0) or (y<0) or (x>=MX) or (y>=MX) ) then 
  begin
     error_quit('Coordinates out of range.');
  end;
end;


function Oracle(x:integer; y:integer; slope:integer):integer;
var
  t,ret: integer;
  outfp,outfp2: text;
begin
  assign(outfp,'news.log'); append(outfp);
  write(outfp,'Oracle (x=');
  write(outfp,x);
  write(outfp,', y=');
  write(outfp,y);
  write(outfp,', slope=');
  write(outfp,slope);
  writeln(outfp,')');
  close(outfp);
 
  if( (slope<1) or (slope>4) ) then
  begin
     error_quit('Bad slope!');
  end;

  initialize;
  checkCoordinates(x,y);
  if( slope=1 ) then ret := sign(solx-x);
  if( slope=2 ) then ret := sign((solx-x) - (soly-y));
  if( slope=3 ) then ret := sign(y-soly);
  if( slope=4 ) then ret := sign((solx-x) + (soly-y));
  cleanup;

  
  assign(outfp2,'news.log'); append(outfp2);
  writeln(outfp2,'returns ', ret);
  close(outfp2);
  Oracle := ret;
end;

procedure Decide( x:integer; y:integer ) ;
var
    outfp, outfp2, outfp3: text;
begin
    assign(outfp,'news.log'); append(outfp);
    writeln(outfp,'Decide (x=',x,', y=',y,');');
	flush(outfp);
    initialize;
    assign(outfp2,'news.out'); rewrite(outfp2);
    writeln(outfp2,x,' ',y);
    close(outfp2);

    checkCoordinates(x,y);
    if( (x=solx) and (y=soly) ) then
    begin
       writeln(outfp,'CORRECT!');
       close(outfp);
       halt(0);
    end
    else
    begin
        writeln(outfp,'Incorrect. Answer is (',solx,', ',soly,').');
        close(outfp);
        halt(1);
    end;
       
end; 

begin
   assign(globaloutfp,'news.log');
   rewrite(globaloutfp);
   writeln(globaloutfp);
   close(globaloutfp);
end.
